<?php
/**
 * Clase Base DP para BasePlaEmpresaColaboradorDP
 *
 * @package    
 * @subpackage BasePlaEmpresaColaboradorDP
 * @author     Willy
 * @version    SVN:: BasePlaEmpresaColaboradorDP.class.php,v 1.1 2022-07-23 14:30:20 william.taype Exp $
 */
abstract class BasePlaEmpresaColaboradorDP extends PlaEmpresaColaboradorBN
{
  /* Número de registros afectados */
  private $nRowsAffected;

  public function __construct($bSetDefault = true)
  {
    if( $bSetDefault instanceof PlaEmpresaColaboradorBN )
    {
      $o_PlaEmpresaColaboradorBN = $bSetDefault;
      if($o_PlaEmpresaColaboradorBN->getIdEmpresaCol()) : $this->setIdEmpresaCol($o_PlaEmpresaColaboradorBN->getIdEmpresaCol()); endif;
      if($o_PlaEmpresaColaboradorBN->getIdEmpresa()) : $this->setIdEmpresa($o_PlaEmpresaColaboradorBN->getIdEmpresa()); endif;
      if($o_PlaEmpresaColaboradorBN->getIdColaborador()) : $this->setIdColaborador($o_PlaEmpresaColaboradorBN->getIdColaborador()); endif;
      if($o_PlaEmpresaColaboradorBN->getFechaCreacion()) : $this->setFechaCreacion($o_PlaEmpresaColaboradorBN->getFechaCreacion()); endif;
      if($o_PlaEmpresaColaboradorBN->getUsuarioCreacion()) : $this->setUsuarioCreacion($o_PlaEmpresaColaboradorBN->getUsuarioCreacion()); endif;
    }
  }

  /* Obtiene el número de registros afectados */
  public function getRowsAffected()
  {
    return $this->nRowsAffected;
  }

  public function save()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT IF(MAX(IdEmpresaCol),(MAX(IdEmpresaCol)+1), 1) AS Maximo FROM pla_empresa_colaborador;";
      $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
      $result = mysql_query($sql, $oLink);
      $row = mysql_fetch_array($result);
      $this->setIdEmpresaCol($row[0]);

      if($this->getIdEmpresaCol()){
        $a_Fields = array();

        if($this->getIdEmpresaCol()) : $a_Fields['IdEmpresaCol'] = ($this->getIdEmpresaCol()); endif;
        if($this->getIdEmpresa()) : $a_Fields['IdEmpresa'] = ($this->getIdEmpresa()); endif;
        if($this->getIdColaborador()) : $a_Fields['IdColaborador'] = ($this->getIdColaborador()); endif;
        if($this->getFechaCreacion()) : $a_Fields['FechaCreacion'] = ($this->getFechaCreacion()); endif;
        if($this->getUsuarioCreacion()) : $a_Fields['UsuarioCreacion'] = ($this->getUsuarioCreacion()); endif;

        $sStringField = arrayClass::implode_keys(',', $a_Fields);
        $sStringValue = "'".implode("','", $a_Fields)."'";

        $sql = "INSERT INTO pla_empresa_colaborador (".$sStringField.") VALUES (".$sStringValue.");";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function update()
  {
    try
    {
      if($this->getIdEmpresaCol())
      {
        $a_Fields = array();

        if($this->getIdEmpresaCol()) : $a_Fields['IdEmpresaCol'] = ($this->getIdEmpresaCol()); endif;
        if($this->getIdEmpresa()) : $a_Fields['IdEmpresa'] = ($this->getIdEmpresa()); endif;
        if($this->getIdColaborador()) : $a_Fields['IdColaborador'] = ($this->getIdColaborador()); endif;
        if($this->getFechaCreacion()) : $a_Fields['FechaCreacion'] = ($this->getFechaCreacion()); endif;
        if($this->getUsuarioCreacion()) : $a_Fields['UsuarioCreacion'] = ($this->getUsuarioCreacion()); endif;

        $sStringField = arrayClass::implode_key_value(',', $a_Fields);

        $con = Conexion::getConexion();
        $sql = "UPDATE pla_empresa_colaborador SET ".$sStringField." WHERE 1 AND IdEmpresaCol='".$this->getIdEmpresaCol()."';";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function delete()
  {
    try
    {
      if($this->getIdEmpresaCol())
      {
        $a_Fields = array();

        $con = Conexion::getConexion();
        $sql = "DELETE FROM pla_empresa_colaborador WHERE 1 AND IdEmpresaCol='".$this->getIdEmpresaCol()."';"; 
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  /* Búsqueda del registro por la llave primaria */
  public static function selectByPK($vIdEmpresaCol)
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT IdEmpresaCol, IdEmpresa, IdColaborador, FechaCreacion, UsuarioCreacion FROM pla_empresa_colaborador WHERE 1 AND IdEmpresaCol='".$vIdEmpresaCol."'; ";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      
      return $o_Propel?self::insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con métodos de acceso */
  private function insertObjectBN($o_propel){
    $o_PlaEmpresaColaboradorDP = new PlaEmpresaColaboradorDP();
    $o_PlaEmpresaColaboradorDP->setIdEmpresaCol($o_propel->IdEmpresaCol);
    $o_PlaEmpresaColaboradorDP->setIdEmpresa($o_propel->IdEmpresa);
    $o_PlaEmpresaColaboradorDP->setIdColaborador($o_propel->IdColaborador);
    $o_PlaEmpresaColaboradorDP->setFechaCreacion($o_propel->FechaCreacion);
    $o_PlaEmpresaColaboradorDP->setUsuarioCreacion($o_propel->UsuarioCreacion);
    return $o_PlaEmpresaColaboradorDP;
  }
}